//go:build cgo && !disable_library_libaom

package main

import (
	"git.gammaspectra.live/S.O.N.G/Ignite/encoder"
	"git.gammaspectra.live/S.O.N.G/Ignite/encoder/libaom"
	"git.gammaspectra.live/S.O.N.G/Ignite/frame"
	"git.gammaspectra.live/S.O.N.G/Ignite/utilities"
	"io"
)

func init() {
	Encoders = append(Encoders, EncoderEntry{
		Name:     EncoderAOM,
		Version:  libaom.Version,
		MimeType: "video/x-ivf",
		New: func(w io.Writer, properties frame.StreamProperties, settings map[string]any, logger utilities.Logger) (encoder.Encoder, error) {
			return libaom.NewEncoder(w, properties, settings, logger)
		},
	})
}
