package encode_utils

import (
	"github.com/shirou/gopsutil/cpu"
	"github.com/shirou/gopsutil/host"
	"github.com/shirou/gopsutil/load"
	"github.com/shirou/gopsutil/mem"
)

type StatusEncoderData struct {
	Name    string
	Version string
}

type StatusData struct {
	Encoders []StatusEncoderData    `json:"encoders"`
	Host     *host.InfoStat         `json:"host,omitempty"`
	Load     *load.AvgStat          `json:"load,omitempty"`
	CPU      []cpu.InfoStat         `json:"cpu"`
	CPULoad  float64                `json:"cpu_load"`
	Memory   *mem.VirtualMemoryStat `json:"memory,omitempty"`
}
