package main

import (
	"flag"
	"fmt"
	"git.gammaspectra.live/S.O.N.G/Ignite/utilities"
	"os"
)

func main() {
	inputPath := flag.String("input", "", "Input timecodes file")
	inputFormat := flag.String("format", "v1", "Input format. Supported: v1")

	flag.Parse()

	f, err := os.Open(*inputPath)
	if err != nil {
		panic(err)
	}
	defer f.Close()

	switch *inputFormat {
	case "v1":
		tc, err := utilities.ParseTimecodesV1(f)
		if err != nil {
			panic(err)
		}
		for _, e := range tc {
			_, _ = fmt.Printf("%d\n", e)
		}
	default:
		panic("unsupported format")
	}
}
