#include "libaom.h"

aom_codec_err_t aom_codec_control_int(aom_codec_ctx_t *ctx, int ctrl_id, int v) {
    return aom_codec_control(ctx, ctrl_id, v);
}

aom_codec_err_t aom_codec_control_uint(aom_codec_ctx_t *ctx, int ctrl_id, unsigned int v) {
    return aom_codec_control(ctx, ctrl_id, v);
}

aom_codec_err_t aom_codec_control_intptr(aom_codec_ctx_t *ctx, int ctrl_id, int* v) {
    return aom_codec_control(ctx, ctrl_id, v);
}

aom_codec_err_t aom_codec_control_charptr(aom_codec_ctx_t *ctx, int ctrl_id, const char* v) {
    return aom_codec_control(ctx, ctrl_id, v);
}

void* aom_get_pkt_buf(aom_codec_cx_pkt_t *pkt){
    return pkt->data.frame.buf;
}

size_t aom_get_pkt_sz(aom_codec_cx_pkt_t *pkt){
  return pkt->data.frame.sz;
}

int aom_get_pkt_partition_id(aom_codec_cx_pkt_t *pkt){
  return pkt->data.frame.partition_id;
}

aom_codec_pts_t aom_get_pkt_pts(aom_codec_cx_pkt_t *pkt){
    return pkt->data.frame.pts;
}

aom_codec_frame_flags_t aom_get_pkt_flags(aom_codec_cx_pkt_t *pkt){
  return pkt->data.frame.flags;
}

const struct aom_codec_enc_cfg* aom_get_ctx_enc_cfg(aom_codec_ctx_t *ctx){
  return ctx->config.enc;
}